diff --git a/drivers/common/qat/meson.build b/drivers/common/qat/meson.build
index 5c36fbb270..2f50302d45 100644
--- a/drivers/common/qat/meson.build
+++ b/drivers/common/qat/meson.build
@@ -9,6 +9,8 @@ endif
 
 qat_crypto = true
 qat_crypto_path = 'crypto/qat'
+qat_crypto_asym = true
+qat_crypto_asym_path = 'crypto/qat_asym'
 qat_crypto_relpath = '../../' + qat_crypto_path
 qat_compress = true
 qat_compress_path = 'compress/qat'
@@ -20,6 +22,12 @@ if disable_drivers.contains(qat_crypto_path)
     set_variable(qat_crypto_path.underscorify() + '_disable_reason',
             'Explicitly disabled via build config')
 endif
+if get_option('disable_drivers').contains(qat_crypto_asym_path)
+    qat_crypto_asym = false
+    dpdk_drvs_disabled += qat_crypto_asym_path
+    set_variable(qat_crypto_asym_path.underscorify() + '_disable_reason',
+            'Explicitly disabled via build config')
+endif
 if disable_drivers.contains(qat_compress_path)
     qat_compress = false
     dpdk_drvs_disabled += qat_compress_path
@@ -102,9 +110,8 @@ endif
 
 if qat_crypto
     foreach f: ['qat_sym.c', 'qat_sym_session.c',
-            'qat_asym.c', 'qat_crypto.c',
+            'qat_crypto.c',
             'dev/qat_sym_pmd_gen1.c',
-            'dev/qat_asym_pmd_gen1.c',
             'dev/qat_crypto_pmd_gen2.c',
             'dev/qat_crypto_pmd_gen3.c',
             'dev/qat_crypto_pmd_gen4.c',
@@ -112,5 +119,14 @@ if qat_crypto
         sources += files(join_paths(qat_crypto_relpath, f))
     endforeach
     deps += ['security']
-    cflags += ['-DBUILD_QAT_SYM', '-DBUILD_QAT_ASYM']
+    cflags += ['-DBUILD_QAT_SYM']
+endif
+
+if qat_crypto_asym
+    foreach f: [ 'qat_asym.c', 'dev/qat_asym_pmd_gen1.c', ]
+        sources += files(join_paths(qat_crypto_relpath, f))
+    endforeach
+    deps += ['security']
+    ext_deps += libcrypto
+    cflags += ['-DBUILD_QAT_ASYM']
 endif
diff --git a/drivers/crypto/qat/dev/qat_crypto_pmd_gen2.c b/drivers/crypto/qat/dev/qat_crypto_pmd_gen2.c
index df47767749..523e74f398 100644
--- a/drivers/crypto/qat/dev/qat_crypto_pmd_gen2.c
+++ b/drivers/crypto/qat/dev/qat_crypto_pmd_gen2.c
@@ -337,6 +337,7 @@ RTE_INIT(qat_sym_crypto_gen2_init)
 			qat_sym_create_security_gen1;
 }
 
+#ifdef BUILD_QAT_ASYM
 RTE_INIT(qat_asym_crypto_gen2_init)
 {
 	qat_asym_gen_dev_ops[QAT_GEN2].cryptodev_ops =
@@ -348,3 +349,4 @@ RTE_INIT(qat_asym_crypto_gen2_init)
 	qat_asym_gen_dev_ops[QAT_GEN2].set_session =
 			qat_asym_crypto_set_session_gen1;
 }
+#endif
diff --git a/drivers/crypto/qat/dev/qat_crypto_pmd_gen3.c b/drivers/crypto/qat/dev/qat_crypto_pmd_gen3.c
index 02bcdb06b1..3fa90bebc9 100644
--- a/drivers/crypto/qat/dev/qat_crypto_pmd_gen3.c
+++ b/drivers/crypto/qat/dev/qat_crypto_pmd_gen3.c
@@ -773,6 +773,7 @@ RTE_INIT(qat_sym_crypto_gen3_init)
 			qat_sym_create_security_gen1;
 }
 
+#ifdef BUILD_QAT_ASYM
 RTE_INIT(qat_asym_crypto_gen3_init)
 {
 	qat_asym_gen_dev_ops[QAT_GEN3].cryptodev_ops =
@@ -784,3 +785,4 @@ RTE_INIT(qat_asym_crypto_gen3_init)
 	qat_asym_gen_dev_ops[QAT_GEN3].set_session =
 			qat_asym_crypto_set_session_gen1;
 }
+#endif
diff --git a/drivers/crypto/qat/dev/qat_crypto_pmd_gen4.c b/drivers/crypto/qat/dev/qat_crypto_pmd_gen4.c
index de72383d4b..d19db0c2aa 100644
--- a/drivers/crypto/qat/dev/qat_crypto_pmd_gen4.c
+++ b/drivers/crypto/qat/dev/qat_crypto_pmd_gen4.c
@@ -419,6 +419,7 @@ RTE_INIT(qat_sym_crypto_gen4_init)
 			qat_sym_create_security_gen1;
 }
 
+#ifdef BUILD_QAT_ASYM
 RTE_INIT(qat_asym_crypto_gen4_init)
 {
 	qat_asym_gen_dev_ops[QAT_GEN4].cryptodev_ops =
@@ -430,3 +431,4 @@ RTE_INIT(qat_asym_crypto_gen4_init)
 	qat_asym_gen_dev_ops[QAT_GEN4].set_session =
 			qat_asym_crypto_set_session_gen1;
 }
+#endif
diff --git a/drivers/crypto/qat/qat_crypto.c b/drivers/crypto/qat/qat_crypto.c
index 861679373b..57590b0086 100644
--- a/drivers/crypto/qat/qat_crypto.c
+++ b/drivers/crypto/qat/qat_crypto.c
@@ -53,8 +53,10 @@ qat_cryptodev_info_get(struct rte_cryptodev *dev,
 			qat_qps_per_service(qat_dev, service_type);
 		info->feature_flags = dev->feature_flags;
 		info->capabilities = qat_private->qat_dev_capabilities;
+#ifdef BUILD_QAT_ASYM
 		if (service_type == QAT_SERVICE_ASYMMETRIC)
 			info->driver_id = qat_asym_driver_id;
+#endif
 
 		if (service_type == QAT_SERVICE_SYMMETRIC)
 			info->driver_id = qat_sym_driver_id;
@@ -168,8 +170,10 @@ qat_cryptodev_qp_setup(struct rte_cryptodev *dev, uint16_t qp_id,
 	for (i = 0; i < qp->nb_descriptors; i++) {
 		if (service_type == QAT_SERVICE_SYMMETRIC)
 			qat_sym_init_op_cookie(qp->op_cookies[i]);
+#ifdef BUILD_QAT_ASYM
 		else
 			qat_asym_init_op_cookie(qp->op_cookies[i]);
+#endif
 	}
 
 	if (qat_private->cipher_crc_offload_enable) {